﻿using Luticate2.Auth.Dbo.Users;
using Luticate2.Utils.Dbo.Basic;
using Luticate2.Utils.Dbo.PaginatedRequest;
using Luticate2.Utils.Dbo.Result;

namespace Luticate2.Auth.Interfaces.Tokens
{
    public interface ILuTokensBusiness
    {
        LuResult<LuUsersTokenDbo> GetToken(string token);

        LuResult<string> RegisterToken(LuUsersTokenDbo token);

        LuResult<LuUsersTokenDbo> UnRegisterToken(string token);

        bool IsTokenValid(LuUsersTokenDbo token);

        LuResult<string> GenerateToken(LuUsersDbo user);

        LuResult<LuPaginatedDbo<LuUsersTokenDbo>> GetTokensForUser(LuUsersDbo user, LuPaginatedRequestDbo paginatedRequestDbo);
    }
}