﻿using System;
using Luticate2.Utils.Interfaces;

namespace Luticate2.Utils.Business
{
    public class LuCrudWebSocketNotificationsBusiness : ILuCrudWebSocketNotificationsBusiness
    {
        private readonly ILuWebSocketNotificationsBusiness _luWebSocketNotificationsBusiness;

        public LuCrudWebSocketNotificationsBusiness(ILuWebSocketNotificationsBusiness luWebSocketNotificationsBusiness)
        {
            _luWebSocketNotificationsBusiness = luWebSocketNotificationsBusiness;
        }

        public void NotifyCreate(Type crudType, object newEntity)
        {
            _luWebSocketNotificationsBusiness.NotifyCrudCreate(crudType.GetCrudEntityType(), newEntity);
        }

        public void NotifyUpdate(Type crudType, object oldEntity, object newEntity)
        {
            _luWebSocketNotificationsBusiness.NotifyCrudUpdate(crudType.GetCrudEntityType(), oldEntity, newEntity);
        }

        public void NotifyDelete(Type crudType, object oldEntity)
        {
            _luWebSocketNotificationsBusiness.NotifyCrudDelete(crudType.GetCrudEntityType(), oldEntity);
        }
    }
}